/*******************************************************************************
********************************************************************************

   COPYRIGHT  2002 Concept 2

   Contains confidential and proprietary information which may not be copied,
   disclosed or used by others except as expressly authorized in writing
   by Concept 2.

   tk_reg.h       External definitions for the Registry Management Toolkit functions

   About:         This module contains external definitions for the Registry
                  Management Toolkit functions of the PM3 Tester in the C2PM3TEST project.

   Target:        Win32 Compatible

   Written for:   Concept 2
                  105 Industrial Park Drive
                  Morrisville, VT 05661
                  802-888-5225 (Voice)
                  802-888-6331 (Fax)

   Contacts:      Scott Hamilton 
                  802-888-5226 x3062 (Voice)
                  scotth@concept2.com

   Written by:    Rob Macklin
                  Microprocessor Designs, Inc.
                  65 Longmeadow Drive
                  PO Box 160
                  Shelburne, VT 05482
                  http://www.updesigns.com

   $Revision: 2 $

--------------------------------------------------------------------------------
   $Log: /Liquid Measurement Systems/LMCH47F/Signal Conditioner/pc_src/Common/tk_reg.h $
 * 
 * 2     1/24/05 4:23p Jpiet
 * Added routines to read/store UINT32 in registry.
 * 
 * 1     11/11/04 10:39a Rmack
 * Initial check-in.
 * 
 * 1     2/26/03 11:17a Rmack
 * Initial check-in
 * 
 * 
********************************************************************************
*******************************************************************************/
#ifndef _TKREG_H
#define _TKREG_H


/* Macros for all toolkit global functions */
#define TKREG_INIT_M(keyname)													\
        tkreg_init(keyname)
#define TKREG_OPEN_STRING_M(name, default_val, buf, buf_size)					\
        tkreg_open_string(name, default_val, buf, buf_size)
#define TKREG_GET_STRING_M(name, buf, buf_size)									\
        tkreg_get_string(name, buf, buf_size)
#define TKREG_SET_STRING_M(name, buf)											\
        tkreg_set_string(name, buf)
#define TKREG_OPEN_UINT32_M(name, default_val, retVal)					\
        tkreg_open_uint32(name, default_val, retVal)
#define TKREG_GET_UINT32_M(name, retVal)									\
        tkreg_get_uint32(name, retVal)
#define TKREG_SET_UINT32_M(name, value)											\
        tkreg_set_uint32(name, value)
#define TKREG_SHUTDOWN_M()														\
        tkreg_shutdown()

/* Prototypes for all toolkit global functions */
ERRCODE_T tkreg_init(INT8_T * keyname);
ERRCODE_T tkreg_open_string(INT8_T * name, INT8_T * default_str, INT8_T * buf, UINT32_T buf_size);
ERRCODE_T tkreg_get_string(INT8_T * name, INT8_T * buf, UINT32_T buf_size);
ERRCODE_T tkreg_set_string(INT8_T * name, INT8_T * buf);
ERRCODE_T tkreg_open_uint32(INT8_T * name, UINT32_T default_val, UINT32_T * retVal);
ERRCODE_T tkreg_get_uint32(INT8_T * name, UINT32_T* retVal);
ERRCODE_T tkreg_set_uint32(INT8_T * name, UINT32_T value);
ERRCODE_T tkreg_shutdown();

#endif /* _TKREG_H */
