﻿Imports System.Windows.Forms
Imports System
Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary


Public Class Pulsar320AppMain

    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) Handles OpenToolStripMenuItem.Click, OpenToolStripButton.Click
        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        OpenFileDialog.Filter = "Pulsar Settings Files (*.str)|*.str|All Files (*.*)|*.*"
        If (OpenFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Dim FileName As String = OpenFileDialog.FileName
            ' TODO: Add code here to open the file.
            loadSettings(FileName)
        End If
    End Sub
    Sub saveSettings(ByVal filename As String)
        Dim childWindow As Config = ActiveMdiChild
        Dim binFor As New BinaryFormatter()
        Dim obFile As FileStream = File.Create(filename)
        binFor.Serialize(obFile, childWindow.GetDialogSettings())
        obFile.Close()
    End Sub
    Sub loadSettings(ByVal filename As String)
        Dim childWindow As Config = ActiveMdiChild
        Dim binFor As New BinaryFormatter()
        Dim obFile As FileStream = File.Open(filename, FileMode.Open)
        Dim dialogSettings As PulsarData
        dialogSettings = binFor.Deserialize(obFile)
        childWindow.SetDialogSettings(dialogSettings)
        obFile.Close()
    End Sub


    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Use My.Computer.Clipboard to insert the selected text or images into the clipboard
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Use My.Computer.Clipboard to insert the selected text or images into the clipboard
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Use My.Computer.Clipboard.GetText() or My.Computer.Clipboard.GetData to retrieve information from the clipboard.
    End Sub

    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CascadeToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileVerticalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileHorizontalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ArrangeIconsToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub

    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CloseAllToolStripMenuItem.Click
        ' Close all child forms of the parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next
    End Sub

    Private m_ChildFormNumber As Integer

    Private Sub FileMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileMenu.Click

    End Sub
    Public Sub launchConfig(ByVal port As Byte, ByVal name As String)
        Dim cfgForm As New Config(port, name, Me)
        cfgForm.Text = name
        cfgForm.MdiParent = Me
        cfgForm.Show()
    End Sub

    Private Sub TCPConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TCPConnect.Click
        ' Create a new instance of the child form.
        Dim connForm As New Connection(Me)
        ' Make it a child of this MDI form before showing it.
        connForm.ShowDialog()
    End Sub
    Public Function ChildConnected(ByVal connected As Boolean) As Boolean
        Query.Enabled = connected
        Settings.Enabled = connected
        SaveToolStripMenuItem.Enabled = connected
        SaveToolStripButton.Enabled = connected
        OpenToolStripButton.Enabled = connected
        OpenToolStripMenuItem.Enabled = connected
    End Function
    Private Sub Query_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Query.Click
        Dim queryDlg As New Query(CType(Me.ActiveMdiChild, Config).GetPulsar()) 'NEED TO PASS POINTER TO PULSAR???
        queryDlg.ShowDialog()
    End Sub

    Private Sub Settings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Settings.Click
        Dim settingsDlg As New Settings(CType(Me.ActiveMdiChild, Config).GetPulsar()) 'NEED TO PASS POINTER TO PULSAR???
        settingsDlg.ShowDialog()
    End Sub

    Private Sub USBConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles USBConnect.Click
        ' Create a new instance of the child form.
        Dim connForm As New USBConnect(Me)
        ' Make it a child of this MDI form before showing it.
        connForm.ShowDialog()
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click, SaveToolStripButton.Click
        Dim SaveFileDialog As New SaveFileDialog
        SaveFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        SaveFileDialog.Filter = "Pulsar Settings Files (*.str)|*.str|All Files (*.*)|*.*"

        If (SaveFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Dim FileName As String = SaveFileDialog.FileName
            ' TODO: Add code here to save the current contents of the form to a file.
            saveSettings(FileName)
        End If
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        Dim strVersion As String
        strVersion = Format(System.Reflection. _
         Assembly.GetExecutingAssembly. _
         GetName.Version.Major, "0")
        strVersion &= "." & Format(System.Reflection. _
         Assembly.GetExecutingAssembly. _
         GetName.Version.Minor, "0")
        strVersion &= Format(System.Reflection. _
         Assembly.GetExecutingAssembly. _
         GetName.Version.Build, "0")

        strVersion = strVersion & "B"
        MessageBox.Show("Advanced Illumination Inc. 2010," & vbCrLf & "Pulsar Software Version " & strVersion, "About Application", MessageBoxButtons.OK)
    End Sub

    Private Sub UserManualToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UserManualToolStripMenuItem.Click
        Try
            Process.Start("Pulsar320Manual.pdf")
        Catch ex As Exception
            MessageBox.Show("Unable to locate Pulsar320Manual.pdf")
        End Try
    End Sub
End Class
